
![Logo](logo_oasis_m.png)

# Oasis Project

본 Oasis (Open-source Architecture Semantic Iot Service-platform) 프로젝트는 국제 표준을 준용하는 오픈 소스 기반 지능형 사물 인터넷 서비스 플랫폼을 개발하는 것을 목표로 하고 있습니다.

본 Oasis 프로젝트는 2015년도 정보통신․방송 기술개발사업 신규지원 대상과제 "(ICBMS-3세부) 사물 가상화, 분산 자율지능 및 데이터 연계/분석을 지원하는 IoT 기반 플랫폼 기술 개발" 과제의 결과물로써 오픈소스로 제공됩니다.

본 Oasis 프로젝트는 오픈 소스 커뮤니티를 기반으로 오픈소스로써 계속적으로 성장해 나갈 계획입니다.

# SO (Service Orchestration) Framework

SO 모듈은 동적으로 생성/변화되는 IoT 환경 (서비스, 센서, 디바이스, 네트워크)에 적응할 수 있는 표준화된 서비스 오케스트레이션 프레임워크로써의 기능을 제공합니다.

## 주요 기능

- IOT 환경에서 동적으로 변화하는 서비스와 서비스 구동 환경 그리고 이벤트 처리 가능
- 서비스 설명, 서비스 목표, 서비스 상세, 비즈니스 명세등의 표준 기반 아키텍처
- 다중 서비스를 하나의 독립적인 서비스로 활용
- 주어진 목표를 수행하기 위해 적절한 서비스를 선택, 구성, 협업 하기 위한 구성요소와 프로세스
- SDA 연동 기능 지원 , 상황 발생 조회 및 인지 
- MariaDB 기반의 리소스 데이터 관리(2차년도 MongoDB 기반)

## Documents
 - [Quick Start](https://github.com/iotoasis/SO/blob/master/so-doc/quick-start.md)
 - [서버 설정방법](https://github.com/iotoasis/SO/blob/master/so-doc/configuration.md)
 - [서버 Build 방법](https://github.com/iotoasis/SO/blob/master/so-doc/build_eclipse.md)

## Downloads
 - [릴리즈 페이지](https://github.com/iotoasis/SO/releases)
 
## Module
- SO Framework는 하나의 서버 모듈로 구성됩니다. 
- SO Framework 시험하기 위해 가상의 서비스를 이용하여 테스트 할 수 있습니다.
- [Test](https://github.com/iotoasis/SO/blob/master/so-doc/so-test.md)
<br>

## Q&A
 - [IoT Oasis Q&A -- soon]

 

v.2.0